/* #INCLUDE instruction support for EditPlus STX and ACP (CTL) files
 * Author: Welman Jordan (wmjordan#163[dot]com)
 * This script loads external STX, ACP or CTL files into the editing file according to the #INCLUDE instructions
 * The loaded file contains <include> and </include> tags. Do not edit or remove them. Otherwise the exclude.js script won't function properly.
 * Date: 2011-12-15
*/

var CMD = /^#(INCLUDE|KEYWORD|T)=(.+)/gi;
var FLAG2 = ";</include>";

var STX = 1;
var ACP = 2;

var o = WScript.StdOut;
var c = []; // main content
var k = {}; // keywords
var ak = null; // active keyword
var st = []; // inclusion stack

function EndsWith (s, w) {
	return s.indexOf(w) == s.length - w.length;
}
function Include (fileName) {
	//WScript.Echo (fileName);
	var fs = new ActiveXObject("Scripting.FileSystemObject");
	var f = fs.OpenTextFile (fileName, 1, false, -2);
	if (f == null) {
		return ;
	}
	ParseFile (f, fileName);
	f.Close ();

}

function ParseFile (file, fileName) {
	var body = false;
	var fn = fileName ? fileName.toLowerCase() : "";
	var mode = EndsWith(fn, ".stx") ? STX // syntax mode
			: EndsWith (fn, ".acp") || EndsWith (fn, ".ctl") ? ACP
			: 0;
	if (mode != 0) {
		for (var i=0; i<st.length; i++) {
			if (st[i] == fn) {
				return;
			}
		}
		st.push(fn);
	}
	var fst = st.length == 1;
	var inc = ";<include file=\""+fileName+"\">";
	var ln = 0;
	while (!file.AtEndOfStream) {
		var l = file.ReadLine ();
		//if (++ln == 1 && l.toUpperCase().indexOf("#TITLE=") != 0) {
			//WScript.StdOut.WriteLine (fileName ? fileName : "file") + " does not start with #TITLE.";
			//WScript.Quit(-1);
		//}
		var m = CMD.exec(l);
		if (m != null) {
			switch (m[1].toUpperCase()) {
			case "INCLUDE":
				var t = ak;
				Include(m[2]);
				ak = t;
				continue;
			case "KEYWORD":
				ak = m[2];
				if (k[ak] == null) {
					k[ak] = [];
				}
				if (mode != 0 && fst) {
					k[ak].push(inc);
				}
				body = true;
				continue;
			case "T":
				if (mode == ACP && !body && fst) {
					c.push(inc);
				}
				body = true;
				break;
			}
		}
		if (mode != 0 && body == false) {
			continue;
		}
		if (ak == null) {
			c.push(l);
		}
		else if (!(mode == STX && l == "#")) {
			k[ak].push(l);
		}
	}
	if (mode) {
		if (mode == ACP && fst) {
			c.push(FLAG2);
		}
		for (var n in k) {
			var a = k[n];
			while (a[a.length - 1].length == 0) {
				a.pop();
			}
			if (fst) {
				a.push(FLAG2);
			}
		}
		st.pop();
	}
}


// main {
	ParseFile (WScript.StdIn);

	var l = c.length;
	for (var i=0; i<l; i++) {
		o.WriteLine (c[i]);
	}
	for (var i in k) {
		o.WriteLine ("#KEYWORD=" + i);
		ak = k[i];
		l = ak.length;
		for (var n=0; n<l; n++) {
			o.WriteLine (ak[n]);
		}
	}
// }
